[fritz2](../../index.md) / [io.fritz2.dom](../index.md) / [Tag](./index.md)

# Tag

`@ExperimentalCoroutinesApi @FlowPreview abstract class Tag<T : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`> : `[`WithDomNode`](../-with-dom-node/index.md)`<T>, `[`WithAttributes`](../-with-attributes/index.md)`<T>, `[`WithEvents`](../-with-events/index.md)`<T>, `[`HtmlElements`](../../io.fritz2.dom.html/-html-elements/index.md)

### Constructors

| [&lt;init&gt;](-init-.md) | `Tag(tagName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, id: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, domNode: T = createDomElement(tagName, id).unsafeCast<T>())` |

### Properties

| [classList](class-list.md) | `var classList: Flow<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>` |
| [className](class-name.md) | `var className: Flow<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>` |
| [domNode](dom-node.md) | `open val domNode: T` |
| [id](id.md) | `val id: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?` |

### Functions

| [bind](bind.md) | `fun <X : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`> Flow<`[`Tag`](./index.md)`<X>>.bind(): `[`SingleMountPoint`](../../io.fritz2.binding/-single-mount-point/index.md)`<`[`WithDomNode`](../-with-dom-node/index.md)`<`[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`>>`<br>`fun <X : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`> `[`Seq`](../../io.fritz2.binding/-seq/index.md)`<`[`Tag`](./index.md)`<X>>.bind(): `[`MultiMountPoint`](../../io.fritz2.binding/-multi-mount-point/index.md)`<`[`WithDomNode`](../-with-dom-node/index.md)`<`[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`>>` |
| [compareTo](compare-to.md) | `operator fun <E : `[`Event`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom.events/-event/index.html)`, X : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`> `[`Handler`](../../io.fritz2.binding/-handler/index.md)`<`[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)`>.compareTo(listener: `[`Listener`](../-listener/index.md)`<E, X>): `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html) |
| [not](not.md) | `operator fun <T> T.not(): `[`Const`](../../io.fritz2.binding/-const/index.md)`<T>` |
| [register](register.md) | `open fun <X : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`, T : `[`Tag`](./index.md)`<X>> register(element: T, content: (T) -> `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)`): T` |

### Extension Functions

| [mount](../mount.md) | `fun <X : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-element/index.html)`> `[`Tag`](./index.md)`<X>.mount(targetId: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html) |

### Inheritors

| [A](../../io.fritz2.dom.html/-a/index.md) | Exposes the JavaScript [HTMLAnchorElement](https://developer.mozilla.org/en/docs/Web/API/HTMLAnchorElement) to Kotlin`class A : `[`Tag`](./index.md)`<`[`HTMLAnchorElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-anchor-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLAnchorElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-anchor-element/index.html)`>` |
| [Area](../../io.fritz2.dom.html/-area/index.md) | Exposes the JavaScript [HTMLAreaElement](https://developer.mozilla.org/en/docs/Web/API/HTMLAreaElement) to Kotlin`class Area : `[`Tag`](./index.md)`<`[`HTMLAreaElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-area-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLAreaElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-area-element/index.html)`>` |
| [Audio](../../io.fritz2.dom.html/-audio/index.md) | Exposes the JavaScript [HTMLAudioElement](https://developer.mozilla.org/en/docs/Web/API/HTMLAudioElement) to Kotlin`class Audio : `[`Tag`](./index.md)`<`[`HTMLAudioElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-audio-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLAudioElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-audio-element/index.html)`>` |
| [Br](../../io.fritz2.dom.html/-br/index.md) | Exposes the JavaScript [HTMLBRElement](https://developer.mozilla.org/en/docs/Web/API/HTMLBRElement) to Kotlin`class Br : `[`Tag`](./index.md)`<`[`HTMLBRElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-b-r-element/index.html)`>` |
| [Button](../../io.fritz2.dom.html/-button/index.md) | Exposes the JavaScript [HTMLButtonElement](https://developer.mozilla.org/en/docs/Web/API/HTMLButtonElement) to Kotlin`class Button : `[`Tag`](./index.md)`<`[`HTMLButtonElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-button-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLButtonElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-button-element/index.html)`>` |
| [Canvas](../../io.fritz2.dom.html/-canvas/index.md) | Exposes the JavaScript [HTMLCanvasElement](https://developer.mozilla.org/en/docs/Web/API/HTMLCanvasElement) to Kotlin`class Canvas : `[`Tag`](./index.md)`<`[`HTMLCanvasElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-canvas-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLCanvasElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-canvas-element/index.html)`>` |
| [Caption](../../io.fritz2.dom.html/-caption/index.md) | Exposes the JavaScript [HTMLTableCaptionElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableCaptionElement) to Kotlin`class Caption : `[`Tag`](./index.md)`<`[`HTMLTableCaptionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-caption-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableCaptionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-caption-element/index.html)`>` |
| [Col](../../io.fritz2.dom.html/-col/index.md) | Exposes the JavaScript [HTMLTableColElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableColElement) to Kotlin`class Col : `[`Tag`](./index.md)`<`[`HTMLTableColElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-col-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableColElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-col-element/index.html)`>` |
| [Colgroup](../../io.fritz2.dom.html/-colgroup/index.md) | Exposes the JavaScript [HTMLTableColElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableColElement) to Kotlin`class Colgroup : `[`Tag`](./index.md)`<`[`HTMLTableColElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-col-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableColElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-col-element/index.html)`>` |
| [Data](../../io.fritz2.dom.html/-data/index.md) | Exposes the JavaScript [HTMLDataElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDataElement) to Kotlin`class Data : `[`Tag`](./index.md)`<`[`HTMLDataElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-data-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDataElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-data-element/index.html)`>` |
| [DataList](../../io.fritz2.dom.html/-data-list/index.md) | Exposes the JavaScript [HTMLDataListElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDataListElement) to Kotlin`class DataList : `[`Tag`](./index.md)`<`[`HTMLDataListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-data-list-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDataListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-data-list-element/index.html)`>` |
| [Del](../../io.fritz2.dom.html/-del/index.md) | Exposes the JavaScript [HTMLModElement](https://developer.mozilla.org/en/docs/Web/API/HTMLModElement) to Kotlin`class Del : `[`Tag`](./index.md)`<`[`HTMLModElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-mod-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLModElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-mod-element/index.html)`>` |
| [Details](../../io.fritz2.dom.html/-details/index.md) | Exposes the JavaScript [HTMLDetailsElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDetailsElement) to Kotlin`class Details : `[`Tag`](./index.md)`<`[`HTMLDetailsElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-details-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDetailsElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-details-element/index.html)`>` |
| [Dialog](../../io.fritz2.dom.html/-dialog/index.md) | Exposes the JavaScript [HTMLDialogElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDialogElement) to Kotlin`class Dialog : `[`Tag`](./index.md)`<`[`HTMLDialogElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-dialog-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDialogElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-dialog-element/index.html)`>` |
| [Div](../../io.fritz2.dom.html/-div/index.md) | Exposes the JavaScript [HTMLDivElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDivElement) to Kotlin`class Div : `[`Tag`](./index.md)`<`[`HTMLDivElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-div-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDivElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-div-element/index.html)`>` |
| [Dl](../../io.fritz2.dom.html/-dl/index.md) | Exposes the JavaScript [HTMLDListElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDListElement) to Kotlin`class Dl : `[`Tag`](./index.md)`<`[`HTMLDListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-d-list-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLDListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-d-list-element/index.html)`>` |
| [Embed](../../io.fritz2.dom.html/-embed/index.md) | Exposes the JavaScript [HTMLDivElement](https://developer.mozilla.org/en/docs/Web/API/HTMLDivElement) to Kotlin`class Embed : `[`Tag`](./index.md)`<`[`HTMLEmbedElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-embed-element/index.html)`>` |
| [FieldSet](../../io.fritz2.dom.html/-field-set/index.md) | Exposes the JavaScript [HTMLFieldSetElement](https://developer.mozilla.org/en/docs/Web/API/HTMLFieldSetElement) to Kotlin`class FieldSet : `[`Tag`](./index.md)`<`[`HTMLFieldSetElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-field-set-element/index.html)`>` |
| [Form](../../io.fritz2.dom.html/-form/index.md) | Exposes the JavaScript [HTMLFormElement](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-form-element/index.html)(https://developer.mozilla.org/en/docs/Web/API/`for`mElement) to Kotlin`class Form : `[`Tag`](./index.md)`<`[`HTMLFormElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-form-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLFormElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-form-element/index.html)`>` |
| [H](../../io.fritz2.dom.html/-h/index.md) | Exposes the JavaScript [HTMLHeadingElement](https://developer.mozilla.org/en/docs/Web/API/HTMLHeadingElement) to Kotlin`class H : `[`Tag`](./index.md)`<`[`HTMLHeadingElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-heading-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLHeadingElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-heading-element/index.html)`>` |
| [Hre](../../io.fritz2.dom.html/-hre/index.md) | Exposes the JavaScript [HTMLHRElement](https://developer.mozilla.org/en/docs/Web/API/HTMLHRElement) to Kotlin`class Hre : `[`Tag`](./index.md)`<`[`HTMLHRElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-h-r-element/index.html)`>` |
| [IFrame](../../io.fritz2.dom.html/-i-frame/index.md) | Exposes the JavaScript [HTMLIFrameElement](https://developer.mozilla.org/en/docs/Web/API/HTMLIFrameElement) to Kotlin`class IFrame : `[`Tag`](./index.md)`<`[`HTMLIFrameElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-i-frame-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLIFrameElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-i-frame-element/index.html)`>` |
| [Img](../../io.fritz2.dom.html/-img/index.md) | Exposes the JavaScript [HTMLImageElement](https://developer.mozilla.org/en/docs/Web/API/HTMLImageElement) to Kotlin`class Img : `[`Tag`](./index.md)`<`[`HTMLImageElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-image-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLImageElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-image-element/index.html)`>` |
| [Input](../../io.fritz2.dom.html/-input/index.md) | Exposes the JavaScript [HTMLInputElement](https://developer.mozilla.org/en/docs/Web/API/HTMLInputElement) to Kotlin`class Input : `[`Tag`](./index.md)`<`[`HTMLInputElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-input-element/index.html)`>` |
| [Ins](../../io.fritz2.dom.html/-ins/index.md) | Exposes the JavaScript [HTMLModElement](https://developer.mozilla.org/en/docs/Web/API/HTMLModElement) to Kotlin`class Ins : `[`Tag`](./index.md)`<`[`HTMLModElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-mod-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLModElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-mod-element/index.html)`>` |
| [Label](../../io.fritz2.dom.html/-label/index.md) | Exposes the JavaScript [HTMLLabelElement](https://developer.mozilla.org/en/docs/Web/API/HTMLLabelElement) to Kotlin`class Label : `[`Tag`](./index.md)`<`[`HTMLLabelElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-label-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLLabelElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-label-element/index.html)`>` |
| [Legend](../../io.fritz2.dom.html/-legend/index.md) | Exposes the JavaScript [HTMLLegendElement](https://developer.mozilla.org/en/docs/Web/API/HTMLLegendElement) to Kotlin`class Legend : `[`Tag`](./index.md)`<`[`HTMLLegendElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-legend-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLLegendElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-legend-element/index.html)`>` |
| [Li](../../io.fritz2.dom.html/-li/index.md) | Exposes the JavaScript [HTMLLIElement](https://developer.mozilla.org/en/docs/Web/API/HTMLLIElement) to Kotlin`class Li : `[`Tag`](./index.md)`<`[`HTMLLIElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-l-i-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLLIElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-l-i-element/index.html)`>` |
| [Map](../../io.fritz2.dom.html/-map/index.md) | Exposes the JavaScript [HTMLMapElement](https://developer.mozilla.org/en/docs/Web/API/HTMLMapElement) to Kotlin`class Map : `[`Tag`](./index.md)`<`[`HTMLMapElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-map-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLMapElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-map-element/index.html)`>` |
| [Meter](../../io.fritz2.dom.html/-meter/index.md) | Exposes the JavaScript [HTMLMeterElement](https://developer.mozilla.org/en/docs/Web/API/HTMLMeterElement) to Kotlin`class Meter : `[`Tag`](./index.md)`<`[`HTMLMeterElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-meter-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLMeterElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-meter-element/index.html)`>` |
| [Object](../../io.fritz2.dom.html/-object/index.md) | Exposes the JavaScript [HTMLObjectElement](https://developer.mozilla.org/en/docs/Web/API/HTMLObjectElement) to Kotlin`class Object : `[`Tag`](./index.md)`<`[`HTMLObjectElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-object-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLObjectElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-object-element/index.html)`>` |
| [Ol](../../io.fritz2.dom.html/-ol/index.md) | Exposes the JavaScript [HTMLOListElement](https://developer.mozilla.org/en/docs/Web/API/HTMLOListElement) to Kotlin`class Ol : `[`Tag`](./index.md)`<`[`HTMLOListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-o-list-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLOListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-o-list-element/index.html)`>` |
| [Optgroup](../../io.fritz2.dom.html/-optgroup/index.md) | Exposes the JavaScript [HTMLOptGroupElement](https://developer.mozilla.org/en/docs/Web/API/HTMLOptGroupElement) to Kotlin`class Optgroup : `[`Tag`](./index.md)`<`[`HTMLOptGroupElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-opt-group-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLOptGroupElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-opt-group-element/index.html)`>` |
| [Option](../../io.fritz2.dom.html/-option/index.md) | Exposes the JavaScript [HTMLOptionElement](https://developer.mozilla.org/en/docs/Web/API/HTMLOptionElement) to Kotlin`class Option : `[`Tag`](./index.md)`<`[`HTMLOptionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-option-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLOptionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-option-element/index.html)`>` |
| [Output](../../io.fritz2.dom.html/-output/index.md) | Exposes the JavaScript [HTMLOutputElement](https://developer.mozilla.org/en/docs/Web/API/HTMLOutputElement) to Kotlin`class Output : `[`Tag`](./index.md)`<`[`HTMLOutputElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-output-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLOutputElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-output-element/index.html)`>` |
| [P](../../io.fritz2.dom.html/-p/index.md) | Exposes the JavaScript [HTMLParagraphElement](https://developer.mozilla.org/en/docs/Web/API/HTMLParagraphElement) to Kotlin`class P : `[`Tag`](./index.md)`<`[`HTMLParagraphElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-paragraph-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLParagraphElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-paragraph-element/index.html)`>` |
| [Param](../../io.fritz2.dom.html/-param/index.md) | Exposes the JavaScript [HTMLParamElement](https://developer.mozilla.org/en/docs/Web/API/HTMLParamElement) to Kotlin`class Param : `[`Tag`](./index.md)`<`[`HTMLParamElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-param-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLParamElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-param-element/index.html)`>` |
| [Picture](../../io.fritz2.dom.html/-picture/index.md) | Exposes the JavaScript [HTMLPictureElement](https://developer.mozilla.org/en/docs/Web/API/HTMLPictureElement) to Kotlin`class Picture : `[`Tag`](./index.md)`<`[`HTMLPictureElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-picture-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLPictureElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-picture-element/index.html)`>` |
| [Pre](../../io.fritz2.dom.html/-pre/index.md) | Exposes the JavaScript [HTMLPreElement](https://developer.mozilla.org/en/docs/Web/API/HTMLPreElement) to Kotlin`class Pre : `[`Tag`](./index.md)`<`[`HTMLPreElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-pre-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLPreElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-pre-element/index.html)`>` |
| [Progress](../../io.fritz2.dom.html/-progress/index.md) | Exposes the JavaScript [HTMLProgressElement](https://developer.mozilla.org/en/docs/Web/API/HTMLProgressElement) to Kotlin`class Progress : `[`Tag`](./index.md)`<`[`HTMLProgressElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-progress-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLProgressElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-progress-element/index.html)`>` |
| [Quote](../../io.fritz2.dom.html/-quote/index.md) | Exposes the JavaScript [HTMLQuoteElement](https://developer.mozilla.org/en/docs/Web/API/HTMLQuoteElement) to Kotlin`class Quote : `[`Tag`](./index.md)`<`[`HTMLQuoteElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-quote-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLQuoteElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-quote-element/index.html)`>` |
| [Script](../../io.fritz2.dom.html/-script/index.md) | Exposes the JavaScript [HTMLScriptElement](https://developer.mozilla.org/en/docs/Web/API/HTMLScriptElement) to Kotlin`class Script : `[`Tag`](./index.md)`<`[`HTMLScriptElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-script-element/index.html)`>` |
| [Select](../../io.fritz2.dom.html/-select/index.md) | Exposes the JavaScript [HTMLSelectElement](https://developer.mozilla.org/en/docs/Web/API/HTMLSelectElement) to Kotlin`class Select : `[`Tag`](./index.md)`<`[`HTMLSelectElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-select-element/index.html)`>` |
| [Span](../../io.fritz2.dom.html/-span/index.md) | Exposes the JavaScript [HTMLSpanElement](https://developer.mozilla.org/en/docs/Web/API/HTMLSpanElement) to Kotlin`class Span : `[`Tag`](./index.md)`<`[`HTMLSpanElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-span-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLSpanElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-span-element/index.html)`>` |
| [Table](../../io.fritz2.dom.html/-table/index.md) | Exposes the JavaScript [HTMLTableElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableElement) to Kotlin`class Table : `[`Tag`](./index.md)`<`[`HTMLTableElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-element/index.html)`>` |
| [TBody](../../io.fritz2.dom.html/-t-body/index.md) | Exposes the JavaScript [HTMLTableSectionElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableSectionElement) to Kotlin`class TBody : `[`Tag`](./index.md)`<`[`HTMLTableSectionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-section-element/index.html)`>` |
| [Td](../../io.fritz2.dom.html/-td/index.md) | Exposes the JavaScript [HTMLTableCellElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableCellElement) to Kotlin`class Td : `[`Tag`](./index.md)`<`[`HTMLTableCellElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-cell-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableCellElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-cell-element/index.html)`>` |
| [TextArea](../../io.fritz2.dom.html/-text-area/index.md) | Exposes the JavaScript [HTMLTextAreaElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTextAreaElement) to Kotlin`class TextArea : `[`Tag`](./index.md)`<`[`HTMLTextAreaElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-text-area-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTextAreaElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-text-area-element/index.html)`>` |
| [TextElement](../../io.fritz2.dom.html/-text-element/index.md) | General class for standard html5 elements`class TextElement : `[`Tag`](./index.md)`<`[`HTMLElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-element/index.html)`>` |
| [TFoot](../../io.fritz2.dom.html/-t-foot/index.md) | Exposes the JavaScript [HTMLTableSectionElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableSectionElement) to Kotlin`class TFoot : `[`Tag`](./index.md)`<`[`HTMLTableSectionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-section-element/index.html)`>` |
| [Th](../../io.fritz2.dom.html/-th/index.md) | Exposes the JavaScript [HTMLTableCellElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableCellElement) to Kotlin`class Th : `[`Tag`](./index.md)`<`[`HTMLTableCellElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-cell-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableCellElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-cell-element/index.html)`>` |
| [THead](../../io.fritz2.dom.html/-t-head/index.md) | Exposes the JavaScript [HTMLTableSectionElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableSectionElement) to Kotlin`class THead : `[`Tag`](./index.md)`<`[`HTMLTableSectionElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-section-element/index.html)`>` |
| [Time](../../io.fritz2.dom.html/-time/index.md) | Exposes the JavaScript [HTMLTimeElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTimeElement) to Kotlin`class Time : `[`Tag`](./index.md)`<`[`HTMLTimeElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-time-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTimeElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-time-element/index.html)`>` |
| [Tr](../../io.fritz2.dom.html/-tr/index.md) | Exposes the JavaScript [HTMLTableRowElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTableRowElement) to Kotlin`class Tr : `[`Tag`](./index.md)`<`[`HTMLTableRowElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-row-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTableRowElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-table-row-element/index.html)`>` |
| [Track](../../io.fritz2.dom.html/-track/index.md) | Exposes the JavaScript [HTMLTrackElement](https://developer.mozilla.org/en/docs/Web/API/HTMLTrackElement) to Kotlin`class Track : `[`Tag`](./index.md)`<`[`HTMLTrackElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-track-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLTrackElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-track-element/index.html)`>` |
| [Ul](../../io.fritz2.dom.html/-ul/index.md) | Exposes the JavaScript [HTMLUListElement](https://developer.mozilla.org/en/docs/Web/API/HTMLUListElement) to Kotlin`class Ul : `[`Tag`](./index.md)`<`[`HTMLUListElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-u-list-element/index.html)`>` |
| [Video](../../io.fritz2.dom.html/-video/index.md) | Exposes the JavaScript [HTMLVideoElement](https://developer.mozilla.org/en/docs/Web/API/HTMLVideoElement) to Kotlin`class Video : `[`Tag`](./index.md)`<`[`HTMLVideoElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-video-element/index.html)`>, `[`WithText`](../-with-text/index.md)`<`[`HTMLVideoElement`](https://kotlinlang.org/api/latest/jvm/stdlib/org.w3c.dom/-h-t-m-l-video-element/index.html)`>` |

